      DOUBLE PRECISION FUNCTION MAP_STEEL_NUCSOLVE
     &     (AREA,ANS,V,SV,BPRE,ALP,ETA,ZETA,XBAR,XAGA,XGAG,TIME,IFAIL)
C
      IMPLICIT NONE                                     
      DOUBLE PRECISION AREA,ANS,V,SV,BPRE,ALP,ETA,ZETA,XBAR,XAGA
      DOUBLE PRECISION XGAG,TIME,MAP_STEEL_NUCSOLVE
      DOUBLE PRECISION B1,B3,FAC,VF1,VF3,B2,VF2,F1,F2,F3
      INTEGER ICOUNT,IFAIL
C
C This subroutine calculates the effective nucleation rate required
C to get the 1% transformation time which matches the calculated TTT 
C curve incubation time.
C
C Start by bracketing the solution.
C
      ICOUNT = 0
      B1     = BPRE*0.4
      B3     = BPRE*1.2
      FAC    = 2.D0
      AREA   = 0.0
      ANS    = 0.0
      ZETA   = 0.0
      IFAIL  = 0
C
  100 CALL MAP_STEEL_AVOLF(AREA,ANS,VF1,SV,B1,TIME,ETA,ALP,
     &                                         ZETA,XBAR,XAGA,XGAG)
      F1 = VF1-V
      CALL MAP_STEEL_AVOLF(AREA,ANS,VF3,SV,B3,TIME,ETA,ALP,
     &                                         ZETA,XBAR,XAGA,XGAG)
      F3     = VF3-V
      ICOUNT = ICOUNT+1
      IF (ICOUNT .GT. 40 ) THEN
C
C        NO BRACKETING IN NUCSOLVE!
C     
         IFAIL = 1 
         RETURN
      ENDIF
      IF (F3 .LT. 0.0) THEN
         B3 = B3*FAC
         GOTO 100
      ENDIF
      IF (F1 .GT. 0.0) THEN
         B1 = B1/FAC
         GOTO 100
      ENDIF
C
  110 B2 = 0.5D0*(B1+B3)
      ICOUNT = ICOUNT+1
      IF (ICOUNT .GT. 40 ) THEN
C
C        NO SOLUTION IN NUCSOLVE!
C
         IFAIL = 2
         GOTO 120
      ENDIF
      CALL MAP_STEEL_AVOLF(AREA,ANS,VF2,SV,B2,TIME,ETA,ALP,
     &                                         ZETA,XBAR,XAGA,XGAG)
      F2 = VF2-V
      IF (DABS(F2/V) .LE. 0.01) GOTO 120
      IF (F3*F2 .LT. 0) THEN
          B1 = B2
          F1 = F2
          GOTO 110
      ELSE
          F3 = F2
          B3 = B2
          GOTO 110
      ENDIF
C
  120 MAP_STEEL_NUCSOLVE = B2
      RETURN      
      END
